%global __strip %{mingw_strip}
%global __objdump %{mingw_objdump}
%global _use_internal_dependency_generator 0
%global __find_requires %{mingw_findrequires}
%global __find_provides %{mingw_findprovides}
%define __debug_install_post %{mingw_debug_install_post}

%global mingw_pkg_name gdbm
%global mingw_build_win32 1
%global mingw_build_win64 1

Name:           mingw-gdbm
Version:        1.8.0
Release:        6%{?dist}
Summary:        MinGW port of GNU database routines

License:        GPLv2+
Group:          Development/Libraries
URL:            http://www.gnu.org/software/gdbm/
Source0:        ftp://ftp.gnu.org/gnu/gdbm/gdbm-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Patch0:         gdbm-1.8.0-jbj.patch
Patch1:         gdbm-1.8.0-fhs.patch
Patch2:         gdbm-1.8.0-cflags.patch
Patch3:         gdbm-1.8.0-64offset.patch

Patch1000:      mingw32-gdbm-1.8.0-windows.patch
Patch1001:      mingw32-gdbm-1.8.0-libtool-install.patch

BuildArch:      noarch

BuildRequires:  mingw-filesystem >= 65
BuildRequires:  mingw32-gcc
BuildRequires:  mingw32-binutils

BuildRequires:  libtool automake

%{?mingw_default_requires}
%{?mingw_debug_package}

%description
Gdbm is a GNU database indexing library, including routines which use
extensible hashing.  Gdbm works in a similar way to standard UNIX dbm
routines.  Gdbm is useful for developers who write C applications and
need access to a simple and efficient database or who are building C
applications which will use such a database.

This is the MinGW Windows port of the libraries and development tools.

# Mingw32
%package -n mingw32-%{mingw_pkg_name}
Summary:        %{summary}

%description  -n mingw32-%{mingw_pkg_name}
Gdbm is a GNU database indexing library, including routines which use
extensible hashing.  Gdbm works in a similar way to standard UNIX dbm
routines.  Gdbm is useful for developers who write C applications and
need access to a simple and efficient database or who are building C
applications which will use such a database.

This is the MinGW Windows port of the libraries and development tools.

# Mingw64
%package -n mingw64-%{mingw_pkg_name}
Summary:        %{summary}

%description -n mingw64-%{mingw_pkg_name}
Gdbm is a GNU database indexing library, including routines which use
extensible hashing.  Gdbm works in a similar way to standard UNIX dbm
routines.  Gdbm is useful for developers who write C applications and
need access to a simple and efficient database or who are building C
applications which will use such a database.

This is the MinGW Windows port of the libraries and development tools.

%prep
%setup -q -n gdbm-%{version}
%patch0 -p 1 -b .jbj
%patch1 -p 1 -b .fhs
%patch2 -p 1 -b .cflags
%patch3 -p1 -b .offset

%patch1000 -p1 -b .windows
%patch1001 -p1 -b .libtool-install


%build
# Update the version of libtool.
libtoolize --force --copy
aclocal

# We want to update config.sub and config.guess because the ones
# shipped with gdbm are ancient history.  However note that there is
# no Makefile.am -- we are only using automake for convenience here!
rm -f config.sub config.guess
automake --add-missing ||:
autoconf

%mingw_configure 
%{mingw_set_suffix}
# NB: why is libtool not placed or referenced correctly?
cp build_win32$suffix/libtool .
make -C build_win32$suffix libdir=%{mingw32_libdir} all progs
cp build_win64$suffix/libtool .
make -C build_win64$suffix libdir=%{mingw64_libdir} all progs
# NB: %{?_smp_mflags} causes build to fail.
%mingw_make all progs

%install
rm -rf $RPM_BUILD_ROOT
make -C build_win32$suffix install prefix=$RPM_BUILD_ROOT%{mingw32_prefix}
make -C build_win64$suffix install prefix=$RPM_BUILD_ROOT%{mingw64_prefix}

# Install the binaries.  Arguable whether we really want these.
pushd build_win32$suffix
install conv2gdbm.exe tdbm.exe testdbm.exe testgdbm.exe testndbm.exe tndbm.exe \
  $RPM_BUILD_ROOT%{mingw32_bindir}
popd

# Install the binaries.  Arguable whether we really want these.
pushd build_win64$suffix
install conv2gdbm.exe tdbm.exe testdbm.exe testgdbm.exe testndbm.exe tndbm.exe \
  $RPM_BUILD_ROOT%{mingw64_bindir}
popd

# Native Fedora package seems to fluff this, but as far as I
# can tell they are trying to create <gdbm/gdbm.h> which
# links to <gdbm.h>.
pushd $RPM_BUILD_ROOT%{mingw32_includedir}
mkdir gdbm
cd gdbm
ln -s ../gdbm.h
popd

pushd $RPM_BUILD_ROOT%{mingw64_includedir}
mkdir gdbm
cd gdbm
ln -s ../gdbm.h
popd

# Remove the static library.
rm $RPM_BUILD_ROOT%{mingw32_libdir}/libgdbm.a
rm $RPM_BUILD_ROOT%{mingw64_libdir}/libgdbm.a

# Remove man page and info file which duplicate what is in native package.
rm -r $RPM_BUILD_ROOT%{mingw32_prefix}/man
rm -r $RPM_BUILD_ROOT%{mingw32_prefix}/info
rm -r $RPM_BUILD_ROOT%{mingw64_prefix}/man
rm -r $RPM_BUILD_ROOT%{mingw64_prefix}/info

%clean
rm -rf $RPM_BUILD_ROOT


# Mingw32
%files -n mingw32-%{mingw_pkg_name}
%defattr(-,root,root)
%{mingw32_bindir}/conv2gdbm.exe
%{mingw32_bindir}/tdbm.exe
%{mingw32_bindir}/testdbm.exe
%{mingw32_bindir}/testgdbm.exe
%{mingw32_bindir}/testndbm.exe
%{mingw32_bindir}/tndbm.exe
%{mingw32_bindir}/libgdbm-2.dll
%{mingw32_libdir}/libgdbm.dll.a
%{mingw32_libdir}/libgdbm.la
%{mingw32_includedir}/gdbm.h
%{mingw32_includedir}/gdbm

# Mingw64
%files -n mingw64-%{mingw_pkg_name}
%defattr(-,root,root)
%{mingw64_bindir}/conv2gdbm.exe
%{mingw64_bindir}/tdbm.exe
%{mingw64_bindir}/testdbm.exe
%{mingw64_bindir}/testgdbm.exe
%{mingw64_bindir}/testndbm.exe
%{mingw64_bindir}/tndbm.exe
%{mingw64_bindir}/libgdbm-2.dll
%{mingw64_libdir}/libgdbm.dll.a
%{mingw64_libdir}/libgdbm.la
%{mingw64_includedir}/gdbm.h
%{mingw64_includedir}/gdbm


%changelog
* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.8.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.8.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.8.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Fri Feb 20 2009 Richard W.M. Jones <rjones@redhat.com> - 1.8.0-3
- Rebuild for mingw32-gcc 4.4

* Sat Jan 17 2009 Richard W.M. Jones <rjones@redhat.com> - 1.8.0-2
- Update config.sub and config.guess.
- Patch to use libtool-2-style commands.

* Fri Oct  3 2008 Richard W.M. Jones <rjones@redhat.com> - 1.8.0-1
- Initial RPM release.
